Intro
=====

This document is designed to provide a list of the minimum levels of
software necessary to run the 2.1.x kernels, as well as provide brief
instructions regarding any other "Gotchas" users may encounter when
trying life on the Bleeding Edge.  If upgrading from a pre-2.0.x
kernel, please consult the Changes file included with 2.0.x kernels for
additional information; most of that information will not be repeated
here.  Basically, this document assumes that your system is already
functional and running at least 2.0.x.

   It is originally based on my "Changes" file for 2.0.x kernels and
therefore owes credit to the same people as that file (Jared Mauch,
Axel Boldt, Alessandro Sigala, and countless other users all over the
'net).  Please feel free to submit changes, corrections, gripes,
flames, money, etc. to me (kaboom@gatech.edu).  If you do so, you don't
need to bother doing so in the form of a diff, as this is generated by
texinfo so a diff is useless anyway (though I can incorporate one by
hand if you insist upon sending it that way ;-).

   Check out
http://www.mindspring.com/~nunez/info/linux/LinuxBleed.html for an
HTML-ized shopping list.

   For those of you in Europe,
http://www.datanet.hu/generations/linux/Changes2.html is an
English-language HTML version.

   The most current version should always be available from
http://cyberbuzz.gatech.edu/kaboom/linux/ as well.

   Also, don't forget http://www.linuxhq.com/ for all your Linux kernel
needs.

Last updated: May 31, 1998
Current Author: Chris Ricker (kaboom@gatech.edu).

Current Minimal Requirements
****************************

   Upgrade to at *least* these software revisions before thinking you've
encountered a bug!  If you're unsure what version you're currently
running, the suggested command should tell you.

- Kernel modules	 modutils-2.1.85         ; insmod -V
- Gnu C 		 2.7.2.3                 ; gcc --version
- Binutils		 2.8.1.0.23              ; ld -v
- Linux C Library	 5.4.44                  ; ls -l /lib/libc.so.*
- Dynamic Linker (ld.so) 1.9.9                   ; ldd --version or ldd -v
- Linux C++ Library	 2.7.2.8                 ; ls -l /usr/lib/libg++.so.*
- Procps		 1.2.7                   ; ps --version
- Procinfo               14                      ; procinfo -v
- Mount                  2.7l                    ; mount --version
- Net-tools              1.45                    ; hostname -V
- Loadlin                1.6a
- Sh-utils               1.16                    ; basename --v
- Autofs                 0.3.11                  ; automount --version
- NFS                    0.4.21                  ; showmount --version
- Bash                   1.14.7                  ; bash -version
- Ncpfs                  2.2.0                   ; ncpmount -v
- Pcmcia-cs              3.0.1
- PPP                    2.3.5                   ; pppd -v

Upgrade notes
*************

General Information
===================

   <CTRL><ALT><DEL> now performs a cold reboot instead of a warm reboot
for increased hardware compatibility.  If you want a warm reboot and
know it works on your hardware, add a "reboot=warm" command line option
in LILO.  A small number of machines need "reboot=bios" to reboot via
the BIOS.

   Also, please remember that cua* devices are now obsolete.  Switch to
the corresponding ttyS* device instead (e.g., cua0 -> ttyS0, cua1 ->
ttyS1, etc.).

   In addition, some software still works, but needs to be compiled
against 2.1 headers for complete functionality.  Fdutils binaries
compiled under 2.0 or earlier kernels should be replaced with ones
compiled under 2.1, for example.

Libc
====

   Linux-2.1.x is ELF-only.  You can still compile a.out apps if you
really want, but your kernel must be compiled ELF.  If you can't
currently compile ELF, consult the ELF howto at
http://sunsite.unc.edu/mdw/HOWTO/ELF-HOWTO.html and upgrade your system
accordingly.

   For modules to work, you need to be running libc-5.4.x or greater.
Since updates to libc fix other problems as well (security flaws, for
example) and since 5.4.7 is missing a few needed symbols, try to get
the latest 5.4.x you can.  Currently, libc-5.4.44 is the latest public
release.

   If you upgrade to libc-5.4.x, you also have to upgrade your dynamic
linker (ld.so) to at least 1.9.5, or all sorts of weirdness will
happen.  Actually, ld.so-1.8.2 and later will work, but 1.9.5 is widely
available, so if you need to upgrade, use it.  If you get a release
later than 1.8.5, avoid 1.8.10 as it introduces a few bugs that are
fixed in later releases.  Please make sure you don't install ld.so-2.x
unless you're running glibc2 / libc6.

   If you upgrade to libc-5.4.x, you may also need to upgrade ypbind if
you're using NIS.

   If you upgrade to libc-5.4.44, please read and pay attention to its
accompanying release notes.  The section about it breaking make is not
a joke.

Modules
=======

   You need to upgrade to modutils-2.1.85 for kernels 2.1.85 and later.
This version will also work with 2.0.x kernels.

   As of 2.1.90-pre1, kerneld has been replaced by a kernel thread,
kmod.  See Documentation/kmod.txt for more information.  The main
user-level change this requires is modification to your init scripts to
check for the absence of /proc/sys/kernel/modprobe before starting
kerneld.

Binutils
========

   If you upgrade binutils, please read its accompanying release notes
to find out the proper way to upgrade it.  No, the instruction to "rm
`which encaps`" is not a joke.

   The last public release of the binutils 2.8.x series was 2.8.1.0.23.
Binutils 2.8.1.0.25 to 2.9.1.0.2 are beta releases, and are known to be
very buggy.  Binutils 2.9.1 (note the absence of a suffix) from the FSF
should work, and binutils 2.9.1.0.3 and later releases are also good.
Either use binutils-2.8.1.0.23 or binutils-2.9.1.0.4 or later.  Glibc2
users should especially try to use the 2.9.1.0.x releases, as they
resolve known issues with glibc2 and binutils-2.8.x releases.

Gnu C
=====

   You need at least GCC 2.7.2 to compile the kernel.  If you're
upgrading from an earlier release, you might as well get GCC 2.7.2.3,
the latest stable public release.  If you already have GCC 2.7.2 on
your system, you don't have to upgrade just so the kernel will work
(though feel free to upgrade if you want the gcc bug fixes).

   Note that the latest compilers (egcs, pgcc, gcc 2.8) may do Bad
Things while compiling your kernel, particularly if absurd
optimizations (like -O9) are used.  Caveat emptor.  Currently, the only
C compiler available in a binary distribution is egcs.  Version 1.0.2
seems okay; if you have to have a binary, you may be successful using
that.  In general, however, gcc-2.7.2.3 is known to be stable, while
egcs and others have not been as thoroughly tested yet.

Networking Changes
==================

   Please read Documentation/networking/routing.txt and
Documentation/networking/policy-routing.txt for more information about
changes in routing code.  OSPF classes have been added, and interface
routes are generated automatically.

   If for some reason you need to override this automatic default
routing, you have to specify the complete route specification (netmask,
device, etc.) for the kernel to accept it. Consequently, you need to
either remove interface routes from your init scripts or add missing
information to them if you need to replace the automatic routes.

   Also note that some routes, such as loopback routes, do not show up
in some standard tools.  Check in /proc/net/rt_local to verify their
presence.

   To turn on IP forwarding, issue the following command:   echo 1 >
/proc/sys/net/ipv4/ip_forward

   To run bootpd, you'll need to issue the following command:   echo 1
>/proc/sys/net/ipv4/ip_boot_agent

   Similar procedures are necessary to turn on other features.  If
something appears broken, check the /proc/sys/net/ipv4/ directory.  "1"
generally denotes enabled, while "0" generally denotes disabled.

   For support for new features like IPv6, upgrade to the latest
net-tools.  This will also fix other problems.  For example, the format
of /proc/net/dev changed; as a result, an older ifconfig will
incorrectly report errors.

   As of 2.1.102, the firewalling code has been replaced with
firewalling chains.  See
http://www.adelaide.net.au/~rustcorp/ipfwchains/ipfwchains.html for
more information.  Among other things, you'll now need to use ipchains
instead of ipfwadm to configure your filters.

   The IP firewalling code has been replaced: ipfwadm will no longer
work.  You need to obtain `ipchains', available from
http://www.adelaide.net.au/~rustcorp/ipfwchains/ipfwchains.html
which includes an ipfwadm wrapper.

Memory
======

   As of 2.1.41, the format of /proc/meminfo has changed.  This broke
many memory utils, which have to be upgraded.  Get the new procps-1.2
and you should be set.

Mount and network file systems
==============================

   The NFS code in the kernel is currently being revised, resulting in
much-improved performance.  As a result, you'll need to upgrade mount
to a recent 2.6 release.  Also, amd is being phased out in favor of the
much better autofs.  You'll also have to get the appropriate utils to
use autofs as well as the new NFS utils.

RPM
===

   If you run Red Hat Linux or any other distribution that uses RPM,
you need to upgrade RPM to version 2.2.7 or later.

DOSEMU
======

   A new "stable" version of DOSEMU is available for 2.1.x kernels.
Upgrade to 0.66.7 or later.

Loadlin
=======

   Linux 2.1.22 and later releases use a new method of memory size
detection, requiring loadlin users to upgrade to loadlin-1.6a.

Sh-utils
========

   As of Linux-2.1.26, the Configure script ("make config") has been
updated to be POSIX-compliant.  As a result, your expr needs to be
updated.  Use sh-utils 1.16 or later.

Parallel Ports
==============

   As of 2.1.33, parallel port support can now by handled by the parport
driver.  Be aware that with Plug-and-Play support turned on, your
parallel port may no longer be where you expect it; for example, LPT1
(under DOS) was sometimes /dev/lp1 in Linux, but will probably be
/dev/lp0 with the new Plug-and-Play driver.  If printing breaks with
the new driver, try checking your lpd configuration.

Syncookies
==========

   When you build your kernel with Syncookie support
(CONFIG_SYN_COOKIES) the syncookie code still defaults to off (unlike
the 2.0.30+ behavior).  You have to explicitly enable it by issuing the
following command:      echo 1 > /proc/sys/net/ipv4/tcp_syncookies

Bash
====

   Old versions of Bash fail to properly handle symlinks, which can
cause problems when compiling modules.  Upgrade to at least 1.14 to fix
this problem.

Ncpfs
=====

   To mount NetWare shares, you'll need to upgrade to a more recent
version of the ncpfs utils.

Pcmcia-cs
=========

   If you use pcmcia cards, you'll need to upgrade the daemon and
support utils to the latest release of pcmcia-cs.

PPP
===

   Due to changes in the routing code, those of you using PPP
networking will need to upgrade your pppd.

Where to get the files
**********************

Binutils
========

The 2.8.1.0.23 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.8.1.0.23.bin.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/binutils-2.8.1.0.23.bin.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.binutils-2.8.1.0.23
ftp://sunsite.unc.edu/pub/Linux/GCC/release.binutils-2.8.1.0.23

The 2.9.1.0.4 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.9.1.0.4-glibc.x86.tar.gz
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.9.1.0.4-libc5.x86.tar.gz
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.9.1.0.4.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/binutils-2.9.1.0.4-glibc.x86.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/binutils-2.9.1.0.4-libc5.x86.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/binutils-2.9.1.0.4.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.binutils-2.9.1.0.4
ftp://sunsite.unc.edu/pub/Linux/GCC/release.binutils-2.9.1.0.4

Gnu C
=====

The 2.7.2.3 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/gcc-2.7.2.3.bin.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/gcc-2.7.2.3.bin.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.gcc-2.7.2.3
ftp://sunsite.unc.edu/pub/Linux/GCC/release.gcc-2.7.2.3

The egcs-1.0.2 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/egcs-1.0.2-glibc.x86.tar.gz
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/egcs-1.0.2-libc5.x86.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/egcs-1.0.2-glibc.x86.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/egcs-1.0.2-libc5.x86.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.egcs-1.0.2
ftp://sunsite.unc.edu/pub/Linux/GCC/release.egcs-1.0.2

Gnu C 2.7.2.3 source:
ftp://prep.ai.mit.edu/pub/gnu/gcc-2.7.2.3.tar.gz
ftp://sunsite.unc.edu/pub/gnu/gcc-2.7.2.3.tar.gz

Linux C Library
===============

The 5.4.44 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/libc-5.4.44.bin.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/libc-5.4.44.bin.tar.gz
Installation notes for 5.4.44:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.libc-5.4.44
ftp://sunsite.unc.edu/pub/Linux/GCC/release.libc-5.4.44

Linux C++ Library
=================

The 2.7.2.8 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/libg++-2.7.2.8.bin.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/libg++-2.7.2.8.bin.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.libg++-2.7.2.8
ftp://sunsite.unc.edu/pub/Linux/GCC/release.libg++-2.7.2.8

Dynamic Linker
==============

The 1.9.9 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/ld.so-1.9.9.tar.gz
ftp://sunsite.unc.edu/pub/Linux/GCC/ld.so-1.9.9.tar.gz

Modules utilities
=================

The 2.1.85 release:
ftp://ftp.kernel.org/pub/linux/kernel/v2.1/modutils-2.1.85.tar.gz

Procps utilities
================

The 1.2 release:
ftp://tsx-11.mit.edu/pub/linux/sources/usr.bin/procps-1.2.7.tar.gz
ftp://sunsite.unc.edu/pub/Linux/system/status/ps/procps-1.2.7.tgz

Procinfo utilities
==================

The 14 release:
ftp://ftp.cistron.nl/pub/people/svm/procinfo-14.tar.gz

RPM utilities
=============

The 2.2.7 release for Intel:
ftp://ftp.redhat.com/pub/redhat/old-releases/redhat-4.0/updates/i386/rpm-2.2.7-1.i386.rpm
ftp://ftp.redhat.com/pub/redhat/old-releases/redhat-4.0/updates/i386/rpm-devel-2.2.7-1.i386.rpm
The 2.2.7 release for Alpha:
ftp://ftp.redhat.com/pub/redhat/old-releases/redhat-4.0/updates/axp/rpm-2.2.7-1.axp.rpm
ftp://ftp.redhat.com/pub/redhat/old-releases/redhat-4.0/updates/axp/rpm-devel-2.2.7-1.axp.rpm
The 2.2.7 release for SPARC:
ftp://ftp.redhat.com/pub/redhat/old-releases/redhat-4.0/updates/sparc/rpm-2.2.7-1.sparc.rpm
ftp://ftp.redhat.com/pub/redhat/old-releases/redhat-4.0/updates/sparc/rpm-devel-2.2.7-1.sparc.rpm

DOSEMU
======

The 0.66.7 release:
ftp://tsx-11.mit.edu/pub/linux/ALPHA/dosemu/dosemu-0.66.7.tgz

Loadlin
=======

The 1.6a release:
ftp://ftp.suse.com/pub/loadlin/update-1.6a/loadlin.exe.gz
ftp://elserv.ffm.fgan.de/pub/linux/loadlin-1.6/update-1.6a/loadlin.exe.gz

Sh-utils
========

The 1.16 release:
ftp://sunsite.unc.edu/pub/gnu/sh-utils-1.16.tar.gz
ftp://prep.ai.mit.edu/pub/gnu/sh-utils-1.16.tar.gz

Mount
=====

The 2.7l release:
ftp://ftp.win.tue.nl/pub/linux/util/mount/mount-2.7l.tar.gz

Autofs
======

The 0.3.11 release:
ftp://ftp.kernel.org/pub/linux/daemons/autofs/autofs-0.3.11.tar.gz

NFS
===

The 0.4.21 release:
ftp://ftp.mathematik.th-darmstadt.de/pub/linux/okir/linux-nfs-0.4.21.tar.gz
ftp://linux.nrao.edu/mirrors/fb0429.mathematik.th-darmstadt.de/pub/linux/okir/linux-nfs-0.4.21.tar.gz

Net-tools
=========

The 1.45 release:
ftp://ftp.cs-ipv6.lancs.ac.uk/pub/Code/Linux/Net_Tools/net-tools-1.45.tar.gz
http://www.tazenda.demon.co.uk/phil/net-tools/net-tools-1.45.tar.gz

Ypbind
======

The 3.2 release:
ftp://ftp.uni-paderborn.de/pub/linux/local/yp/ypbind-3.2.tar.gz

Bash
====

The 1.14.7 release:
ftp://prep.ai.mit.edu/pub/gnu/bash-1.14.7.tar.gz

Ncpfs
=====

The 2.2.0 release:
ftp://ftp.gwdg.de/pub/linux/misc/ncpfs/ncpfs-2.2.0.tgz

Pcmcia-cs
=========

The 3.0.1 release:
ftp://hyper.stanford.edu/pub/pcmcia/pcmcia-cs.3.0.1.tar.gz

PPP
===

The 2.3.5 release:
ftp://cs.anu.edu.au/pub/software/ppp/ppp-2.3.5.tar.gz

IP Chains
=========

The 1.3.3 release:
http://www.adelaide.net.au/~rustcorp/ipfwchains/ipchains-source-1.3.3.tar.gz
http://www.adelaide.net.au/~rustcorp/ipfwchains/ipchains-source-1.3.3.tar.bz2

Other Info
==========

   Please remember that most of these utils are available on your
favorite local linux mirror.  If you can, please get them from a closer
site before checking sunsite.

   You may also want to check for updated versions of this software in a
package format for the distribution you use.

   For those of you running Red Hat (or RPM on a different
distribution), most of these are available in RPM format.  Check around
your favorite Red Hat mirror site before installing the non-RPM
version.  Remember, you might need to use the -force option to get the
upgrade to install.  ftp://ftp.redhat.com/pub/contrib/ will have almost
everything you need, as does Red Hat 5.0.

   Those of you running Debian (or a different distribution that
supports .deb packages) can look in the "unstable" and
"project/experimental" directories of your favorite Debian mirror.  The
Debian 2.0 release should have most packages you need as well.

   For others, David Bourgin has put together a package of everything
necessary to quickly and easily upgrade to 2.1.x.  See
ftp://ftp.wsc.com/pub/freeware/linux/update.linux/kernel-v2.1.x/ for
more information and the files.

Please send info about any other packages that 2.1.x "broke" or about
any new features of 2.1.x that require extra or new packages for use to
Chris Ricker (kaboom@gatech.edu).

